from dark_stew.pgfw.Game import Game
from dark_stew.pgfw.Configuration import TypeDeclarations
from dark_stew.World import World
from dark_stew.monster.Monsters import Monsters

class DarkStew(Game):

    def __init__(self):
        Game.__init__(self, type_declarations=Types())

    def set_children(self):
        Game.set_children(self)
        self.world = World(self)
        self.monsters = Monsters(self)

    def update(self):
        self.world.update()
        self.monsters.update()


class Types(TypeDeclarations):

    additional_defaults = {

        "joy": {"int": ["run", "action"]},

        "world": {"int-list": "dimensions",

                  "int": ["walk-step", "run-step"],

                  "path": "audio-path"},

        "floor": {"path": ["tile-path", "film-path"],

                  "int": "film-opacity"},

        "water": {"float-list": "speed",

                  "path": "tile-path",

                  "int-list": ["color", "opacity"]},

        "pool": {"int": ["framerate", "padding"],

                 "path": ["water-path", "ring-path", "led-path"]},

        "stool": {"path": "path",

                  "float-list": ["angles", "offsets"]},

        "led": {"path": "path",

                "float": ["angle", "offset"]},

        "aphids": {"path": ["path", "animation-path", "moving-path",
                            "standing-path", "sitting-path", "back-path",
                            "front-path", "side-path", "rod-path", "line-path"],

                   "int": ["rest-framerate", "walk-framerate", "run-framerate"],

                   "int-list": "collision-rect",

                   "float": ["initial-chance", "chance-increase"]},

        "monsters": {"path": "path",

                     "int": ["shadow-offset", "shadow-alpha"]},

        }
