from pygame import Surface
from pygame.image import load

from dark_stew.pgfw.GameChild import GameChild

class Monster(GameChild):

    def __init__(self, parent, path):
        GameChild.__init__(self, parent)
        self.path = path
        self.display_surface = self.get_display_surface()
        self.set_image()
        self.set_shadow()

    def set_image(self):
        image = load(self.path).convert()
        rect = image.get_rect()
        rect.center = self.display_surface.get_rect().center
        offset = self.parent.shadow_offset / 2
        rect.move_ip(-offset, -offset)
        self.image = image
        self.image_rect = rect

    def set_shadow(self):
        shadow = Surface(self.image.get_size())
        parent = self.parent
        shadow.fill(parent.shadow_color)
        rect = shadow.get_rect()
        rect.center = self.display_surface.get_rect().center
        offset = parent.shadow_offset / 2
        rect.move_ip(offset, offset)
        shadow.set_alpha(parent.shadow_alpha)
        self.shadow = shadow
        self.shadow_rect = rect

    def draw(self):
        surface = self.display_surface
        surface.blit(self.shadow, self.shadow_rect)
        surface.blit(self.image, self.image_rect)
