from os import listdir
from os.path import join
from random import choice

from pygame import Color

from dark_stew.pgfw.GameChild import GameChild
from dark_stew.monster.Monster import Monster

class Monsters(GameChild, list):

    def __init__(self, parent):
        GameChild.__init__(self, parent)
        self.current = None
        self.delegate = self.get_delegate()
        self.load_configuration()
        self.add_monsters()

    def load_configuration(self):
        config = self.get_configuration("monsters")
        self.shadow_color = Color(config["shadow-color"])
        self.shadow_offset = config["shadow-offset"]
        self.shadow_alpha = config["shadow-alpha"]
        self.path = self.get_resource("monsters", "path")

    def add_monsters(self):
        root = self.path
        for path in [join(root, name) for name in sorted(listdir(root))]:
            self.append(Monster(self, path))

    def open_random(self):
        self.current = choice(self)

    def close(self):
        self.current = None

    def update(self):
        if self.current:
            self.current.draw()
